Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.xml
Class QDomDocument

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.xml.QDomNode
                      com.trolltech.qt.xml.QDomDocument

All Implemented Interfaces:
  QtJambiInterface, java.lang.Cloneable

    public class QDomDocument

extends QDomNode
implements java.lang.Cloneable

The `QDomDocument` class represents an XML document. The `QDomDocument` class represents the entire XML document. Conceptually, it is the root of the document tree, and provides the primary access to the document's data.

Since elements, text nodes, comments, processing instructions, etc., cannot exist outside the context of a document, the document class also contains the factory functions needed to create these objects. The node objects created have an `ownerDocument()` function which associates them with the document within whose context they were created. The DOM classes that will be used most often are `QDomNode`, `QDomDocument`, `QDomElement` and `QDomText`.

The parsed XML is represented internally by a tree of objects that can be accessed using the various `QDom` classes. All `QDom` classes only reference objects in the internal tree. The internal objects in the DOM tree will get deleted once the last `QDom` object referencing them and the `QDomDocument` itself are deleted.

Creation of elements, text nodes, etc. is done using the various factory functions provided in this class. Using the default constructors of the `QDom` classes will only result in empty objects that cannot be manipulated or inserted into the Document.

The `QDomDocument` class has several functions for creating document data, for example, `createElement()`, `createTextNode()`, `createComment()`, `createCDATASection()`, `createProcessingInstruction()`, `createAttribute()` and `createEntityReference()`. Some of these functions have versions that support namespaces, i.e. `createElementNS()` and `createAttributeNS()`. The `createDocumentFragment()` function is used to hold parts of the document; this is useful for manipulating for complex documents.

The entire content of the document is set with `setContent()`. This function parses the string it is passed as an XML document and creates the DOM tree that represents the document. The root element is available using `documentElement()`. The textual representation of the document can be obtained using `toString()`.

It is possible to insert a node from another document into the document using `importNode()`.

You can obtain a list of all the elements that have a particular tag with `elementsByTagName()` or with `elementsByTagNameNS()`.

The `QDom` classes are typically used as follows:

        QDomDocument domDoc = new QDomDocument("mydocument");
        QFile file = new QFile("mydocument.xml");
        QFile.OpenMode mode = new QFile.OpenMode();
        mode.set(QFile.OpenModeFlag.ReadOnly);

        if (!file.open(mode))
            return;
        if (!domDoc.setContent(file).success) {
            file.close();
            return;
        }
        file.close();

        // print out the element names of all elements that are direct children
        // of the outermost element.
        QDomElement docElem = doc.documentElement();

        QDomNode domNode = docElem.firstChild();
        while(!domNode.isNull()) {
            QDomElement e = domNode.toElement(); // try to convert the node to an element.
            if(!e.isNull()) {
                System.out.println(e.tagName()); // the node really is an element.
            }
            domNode = domNode.nextSibling();
        }

        // Here we append a new element to the end of the document
        QDomElement elem = doc.createElement("img");
        elem.setAttribute("src", "myimage.png");
        docElem.appendChild(elem);

Once `doc` and `elem` go out of scope, the whole internal tree representing the XML document is deleted.

To create a document using DOM use code like this:

        QDomDocument doc = new QDomDocument("MyML");
        QDomElement root = doc.createElement("MyML");
        doc.appendChild(root);

        QDomElement tag = doc.createElement("Greeting");
        root.appendChild(tag);

        QDomText t = doc.createTextNode("Hello World");
        tag.appendChild(t);

        java.lang.String xml = doc.toString();

For further information about the Document Object Model see the Document Object Model (DOM) Level 1 and Level 2 Core Specifications.

See also:
  DOM Bookmarks Example, and Simple DOM Model Example.

Nested Class Summary
`class` | `QDomDocument.Result`

Nested classes/interfaces inherited from class com.trolltech.qt.xml.QDomNode
`QDomNode.EncodingPolicy, QDomNode.NodeType`

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QDomDocument()` Constructs an empty document.
`QDomDocument(QDomDocument x)` Constructs a copy of `x`.
`QDomDocument(QDomDocumentType doctype)` Creates a document with the document type `doctype`.
`QDomDocument(java.lang.String name)` Creates a document and sets the name of the document type to `name`.

Method Summary
`QDomDocument` | `clone()` This method is reimplemented for internal reasons
`QDomAttr` | `createAttribute(java.lang.String name)` Creates a new attribute called `name` that can be inserted into an element, e.g.
`QDomAttr` | `createAttributeNS(java.lang.String nsURI, java.lang.String qName)` Creates a new attribute with namespace support that can be inserted into an element.
`QDomCDATASection` | `createCDATASection(java.lang.String data)` Creates a new CDATA section for the string `value` that can be inserted into the document, e.g.
`QDomComment` | `createComment(java.lang.String data)` Creates a new comment for the string `value` that can be inserted into the document, e.g.
`QDomDocumentFragment` | `createDocumentFragment()` Creates a new document fragment, that can be used to hold parts of the document, e.g.
`QDomElement` | `createElement(java.lang.String tagName)` Creates a new element called `tagName` that can be inserted into the DOM tree, e.g.
`QDomElement` | `createElementNS(java.lang.String nsURI, java.lang.String qName)` Creates a new element with namespace support that can be inserted into the DOM tree.
`QDomEntityReference` | `createEntityReference(java.lang.String name)` Creates a new entity reference called `name` that can be inserted into the document, e.g.
`QDomProcessingInstruction` | `createProcessingInstruction(java.lang.String target, java.lang.String data)` Creates a new processing instruction that can be inserted into the document, e.g.
`QDomText` | `createTextNode(java.lang.String data)` Creates a text node for the string `value` that can be inserted into the document tree, e.g.
`QDomDocumentType` | `doctype()` Returns the document type of this document.
`QDomElement` | `documentElement()` Returns the root element of the document.
`QDomElement` | `elementById(java.lang.String elementId)` Returns the element whose ID is equal to `elementId`.
`QDomNodeList` | `elementsByTagName(java.lang.String tagname)` Returns a `QDomNodeList`, that contains all the elements in the document with the name `tagname`.
`QDomNodeList` | `elementsByTagNameNS(java.lang.String nsURI, java.lang.String localName)` Returns a `QDomNodeList` that contains all the elements in the document with the local name `localName` and a namespace URI of `nsURI`.
`QDomImplementation` | `implementation()` Returns a `QDomImplementation` object.
`QDomNode` | `importNode(QDomNode importedNode, boolean deep)` Imports the node `importedNode` from another document to this document.
`QDomDocument.Result` | `setContent(QByteArray buffer)` This is an overloaded method provided for convenience.
`QDomDocument.Result` | `setContent(QByteArray text, boolean namespaceProcessing)` This function reads the XML document from the byte array `text`, returning true if the content was successfully parsed; otherwise returns false.
`QDomDocument.Result` | `setContent(QIODevice dev)` This is an overloaded method provided for convenience.
`QDomDocument.Result` | `setContent(QIODevice dev, boolean namespaceProcessing)` This function reads the XML document from the IO device `dev`, returning true if the content was successfully parsed; otherwise returns false.
`QDomDocument.Result` | `setContent(QXmlInputSource source, QXmlReader reader)` This function reads the XML document from the QXmlInputSource `source` and parses it with the QXmlReader `reader`, returning true if the content was successfully parsed; otherwise returns false.
`QDomDocument.Result` | `setContent(java.lang.String text)` This is an overloaded method provided for convenience.
`QDomDocument.Result` | `setContent(java.lang.String text, boolean namespaceProcessing)` This function reads the XML document from the string `text`, returning true if the content was successfully parsed; otherwise returns false.
`QByteArray` | `toByteArray()` Converts the parsed document back to its textual representation and returns a `QByteArray` containing the data encoded as UTF-8.
`QByteArray` | `toByteArray(int arg__1)` Converts the parsed document back to its textual representation and returns a `QByteArray` containing the data encoded as UTF-8.
`java.lang.String` | `toString()` Returns a string representation of the `this QDomDocument`.
`java.lang.String` | `toString(int arg__1)` Returns a string representation of the `int` argument.

Methods inherited from class com.trolltech.qt.xml.QDomNode
`appendChild, childNodes, clear, cloneNode, cloneNode, columnNumber, firstChild, firstChildElement, firstChildElement, hasAttributes, hasChildNodes, insertAfter, insertBefore, isAttr, isCDATASection, isCharacterData, isComment, isDocument, isDocumentFragment, isDocumentType, isElement, isEntity, isEntityReference, isNotation, isNull, isProcessingInstruction, isSupported, isText, lastChild, lastChildElement, lastChildElement, lineNumber, localName, namedItem, namespaceURI, nextSibling, nextSiblingElement, nextSiblingElement, nodeName, nodeType, nodeValue, normalize, ownerDocument, parentNode, prefix, previousSibling, previousSiblingElement, previousSiblingElement, removeChild, replaceChild, save, save, setNodeValue, setPrefix, toAttr, toCDATASection, toCharacterData, toComment, toDocument, toDocumentFragment, toDocumentType, toElement, toEntity, toEntityReference, toNotation, toProcessingInstruction, toText, writeTo`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QDomDocument

    public QDomDocument()

  Constructs an empty document.

### QDomDocument

    public QDomDocument(QDomDocument x)

  Constructs a copy of `x`.

  The data of the copy is shared (shallow copy): modifying one node will also change the other. If you want to make a deep copy, use `cloneNode()`.

### QDomDocument

    public QDomDocument(QDomDocumentType doctype)

  Creates a document with the document type `doctype`.

See also:
  `QDomImplementation::createDocumentType()`.

### QDomDocument

    public QDomDocument(java.lang.String name)

  Creates a document and sets the name of the document type to `name`.

Method Detail

### createAttribute

    public final QDomAttr createAttribute(java.lang.String name)

  Creates a new attribute called `name` that can be inserted into an element, e.g. using `QDomElement::setAttributeNode()`.

  If `name` is not a valid XML name, the behavior of this function is governed by `QDomImplementation::InvalidDataPolicy` .

See also:
  `createAttributeNS()`.

### createAttributeNS

    public final QDomAttr createAttributeNS(java.lang.String nsURI,
                                            java.lang.String qName)

  Creates a new attribute with namespace support that can be inserted into an element. The name of the attribute is `qName` and the namespace URI is `nsURI`. This function also sets `QDomNode::prefix()` and `QDomNode::localName()` to appropriate values (depending on `qName`).

  If `qName` is not a valid XML name, the behavior of this function is governed by `QDomImplementation::InvalidDataPolicy` .

See also:
  `createAttribute()`.

### createCDATASection

    public final QDomCDATASection createCDATASection(java.lang.String data)

  Creates a new CDATA section for the string `value` that can be inserted into the document, e.g. using `QDomNode::appendChild()`.

  If `value` contains characters which cannot be stored in a CDATA section, the behavior of this function is governed by `QDomImplementation::InvalidDataPolicy` .

See also:
  `QDomNode::appendChild()`, `QDomNode::insertBefore()`, and `QDomNode::insertAfter()`.

### createComment

    public final QDomComment createComment(java.lang.String data)

  Creates a new comment for the string `value` that can be inserted into the document, e.g. using `QDomNode::appendChild()`.

  If `value` contains characters which cannot be stored in an XML comment, the behavior of this function is governed by `QDomImplementation::InvalidDataPolicy` .

See also:
  `QDomNode::appendChild()`, `QDomNode::insertBefore()`, and `QDomNode::insertAfter()`.

### createDocumentFragment

    public final QDomDocumentFragment createDocumentFragment()

  Creates a new document fragment, that can be used to hold parts of the document, e.g. when doing complex manipulations of the document tree.

### createElement

    public final QDomElement createElement(java.lang.String tagName)

  Creates a new element called `tagName` that can be inserted into the DOM tree, e.g. using `QDomNode::appendChild()`.

  If `tagName` is not a valid XML name, the behavior of this function is governed by `QDomImplementation::InvalidDataPolicy` .

  `QDomNode::insertAfter()`

See also:
  `createElementNS()`, `QDomNode::appendChild()`, and `QDomNode::insertBefore()`.

### createElementNS

    public final QDomElement createElementNS(java.lang.String nsURI,
                                             java.lang.String qName)

  Creates a new element with namespace support that can be inserted into the DOM tree. The name of the element is `qName` and the namespace URI is `nsURI`. This function also sets `QDomNode::prefix()` and `QDomNode::localName()` to appropriate values (depending on `qName`).

  If `qName` is an empty string, returns a null element regardless of whether the invalid data policy is set.

See also:
  `createElement()`.

### createEntityReference

    public final QDomEntityReference createEntityReference(java.lang.String name)

  Creates a new entity reference called `name` that can be inserted into the document, e.g. using `QDomNode::appendChild()`.

  If `name` is not a valid XML name, the behavior of this function is governed by `QDomImplementation::InvalidDataPolicy` .

See also:
  `QDomNode::appendChild()`, `QDomNode::insertBefore()`, and `QDomNode::insertAfter()`.

### createProcessingInstruction

    public final QDomProcessingInstruction createProcessingInstruction(java.lang.String target,
                                                                       java.lang.String data)

  Creates a new processing instruction that can be inserted into the document, e.g. using `QDomNode::appendChild()`. This function sets the target for the processing instruction to `target` and the data to `data`.

  If `target` is not a valid XML name, or data if contains characters which cannot appear in a processing instruction, the behavior of this function is governed by `QDomImplementation::InvalidDataPolicy` .

See also:
  `QDomNode::appendChild()`, `QDomNode::insertBefore()`, and `QDomNode::insertAfter()`.

### createTextNode

    public final QDomText createTextNode(java.lang.String data)

  Creates a text node for the string `value` that can be inserted into the document tree, e.g. using `QDomNode::appendChild()`.

  If `value` contains characters which cannot be stored as character data of an XML document (even in the form of character references), the behavior of this function is governed by `QDomImplementation::InvalidDataPolicy` .

See also:
  `QDomNode::appendChild()`, `QDomNode::insertBefore()`, and `QDomNode::insertAfter()`.

### doctype

    public final QDomDocumentType doctype()

  Returns the document type of this document.

### documentElement

    public final QDomElement documentElement()

  Returns the root element of the document.

### elementById

    public final QDomElement elementById(java.lang.String elementId)

  Returns the element whose ID is equal to `elementId`. If no element with the ID was found, this function returns a `null element`.

  Since the `QDomClasses` do not know which attributes are element IDs, this function returns always a `null element`. This may change in a future version.

### elementsByTagName

    public final QDomNodeList elementsByTagName(java.lang.String tagname)

  Returns a `QDomNodeList`, that contains all the elements in the document with the name `tagname`. The order of the node list is the order they are encountered in a preorder traversal of the element tree.

See also:
  `elementsByTagNameNS()`, and `QDomElement::elementsByTagName()`.

### elementsByTagNameNS

    public final QDomNodeList elementsByTagNameNS(java.lang.String nsURI,
                                                  java.lang.String localName)

  Returns a `QDomNodeList` that contains all the elements in the document with the local name `localName` and a namespace URI of `nsURI`. The order of the node list is the order they are encountered in a preorder traversal of the element tree.

See also:
  `elementsByTagName()`, and `QDomElement::elementsByTagNameNS()`.

### implementation

    public final QDomImplementation implementation()

  Returns a `QDomImplementation` object.

### importNode

    public final QDomNode importNode(QDomNode importedNode,
                                     boolean deep)

  Imports the node `importedNode` from another document to this document. `importedNode` remains in the original document; this function creates a copy that can be used within this document.

  This function returns the imported node that belongs to this document. The returned node has no parent. It is not possible to import `QDomDocument` and `QDomDocumentType` nodes. In those cases this function returns a `null node`.

  If `deep` is true, this function imports not only the node `importedNode` but its whole subtree; if it is false, only the `importedNode` is imported. The argument `deep` has no effect on `QDomAttr` and `QDomEntityReference` nodes, since the descendants of `QDomAttr` nodes are always imported and those of `QDomEntityReference` nodes are never imported.

  The behavior of this function is slightly different depending on the node types:

  Node Type | Behavior
  --- | ---
  `QDomAttr` | The owner element is set to 0 and the specified flag is set to true in the generated attribute. The whole subtree of `importedNode` is always imported for attribute nodes: `deep` has no effect.
  `QDomDocument` | Document nodes cannot be imported.
  `QDomDocumentFragment` | If `deep` is true, this function imports the whole document fragment; otherwise it only generates an empty document fragment.
  `QDomDocumentType` | Document type nodes cannot be imported.
  `QDomElement` | Attributes for which `QDomAttr::specified()` is true are also imported, other attributes are not imported. If `deep` is true, this function also imports the subtree of `importedNode`; otherwise it imports only the element node (and some attributes, see above).
  `QDomEntity` | Entity nodes can be imported, but at the moment there is no way to use them since the document type is read-only in DOM level 2.
  `QDomEntityReference` | Descendants of entity reference nodes are never imported: `deep` has no effect.
  `QDomNotation` | Notation nodes can be imported, but at the moment there is no way to use them since the document type is read-only in DOM level 2.
  `QDomProcessingInstruction` | The target and value of the processing instruction is copied to the new node.
  `QDomText` | The text is copied to the new node.
  `QDomCDATASection` | The text is copied to the new node.
  `QDomComment` | The text is copied to the new node.

  `QDomNode::insertAfter()``QDomNode::replaceChild()``QDomNode::removeChild()``QDomNode::appendChild()`

See also:
  `QDomElement::setAttribute()`, and `QDomNode::insertBefore()`.

### toByteArray

    public final QByteArray toByteArray()

  Converts the parsed document back to its textual representation and returns a `QByteArray` containing the data encoded as UTF-8.

  This function uses `indent` as the amount of space to indent subelements.

See also:
  `toString()`.

### toByteArray

    public final QByteArray toByteArray(int arg__1)

  Converts the parsed document back to its textual representation and returns a `QByteArray` containing the data encoded as UTF-8.

  This function uses `indent` as the amount of space to indent subelements.

See also:
  `toString()`.

### toString

    public final java.lang.String toString()

  Returns a string representation of the `this QDomDocument`.

  Overrides:
    `toString` in class `java.lang.Object`

### toString

    public final java.lang.String toString(int arg__1)

  Returns a string representation of the `int` argument.

### setContent

    public final QDomDocument.Result setContent(QIODevice dev,
                                                boolean namespaceProcessing)

  This function reads the XML document from the IO device `dev`, returning true if the content was successfully parsed; otherwise returns false.

  If `namespaceProcessing` is true, the parser recognizes namespaces in the XML file and sets the prefix name, local name and namespace URI to appropriate values. If `namespaceProcessing` is false, the parser does no namespace processing when it reads the XML file.

### setContent

    public final QDomDocument.Result setContent(QByteArray text,
                                                boolean namespaceProcessing)

  This function reads the XML document from the byte array `text`, returning true if the content was successfully parsed; otherwise returns false.

  If `namespaceProcessing` is true, the parser recognizes namespaces in the XML file and sets the prefix name, local name and namespace URI to appropriate values. If `namespaceProcessing` is false, the parser does no namespace processing when it reads the XML file.

### setContent

    public final QDomDocument.Result setContent(java.lang.String text,
                                                boolean namespaceProcessing)

  This function reads the XML document from the string `text`, returning true if the content was successfully parsed; otherwise returns false. Since `text` is already a Unicode string, no encoding detection is performed.

  If `namespaceProcessing` is true, the parser recognizes namespaces in the XML file and sets the prefix name, local name and namespace URI to appropriate values. If `namespaceProcessing` is false, the parser does no namespace processing when it reads the XML file.

### setContent

    public final QDomDocument.Result setContent(QXmlInputSource source,
                                                QXmlReader reader)

  This function reads the XML document from the QXmlInputSource `source` and parses it with the QXmlReader `reader`, returning true if the content was successfully parsed; otherwise returns false.

  This function doesn't change the features of the `reader`. If you want to use certain features for parsing you can use this function to set up the reader appropriately.

### setContent

    public final QDomDocument.Result setContent(java.lang.String text)

  This is an overloaded method provided for convenience.

### setContent

    public final QDomDocument.Result setContent(QByteArray buffer)

  This is an overloaded method provided for convenience.

### setContent

    public final QDomDocument.Result setContent(QIODevice dev)

  This is an overloaded method provided for convenience.

### clone

    public QDomDocument clone()

  This method is reimplemented for internal reasons

  Overrides:
    `clone` in class `QDomNode`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD